﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data;
using System.Data.SqlClient;
using System.IO;

namespace 统计手机数据_一个月平均到一个星期
{
    class Program
    {
        static int n_hours = 168;  //7天小时总数 7*24
        static string outPath01 = "E:\\MobileData\\手机基站分时段统计_2017\\sum.csv";
        static string outPath02 = "E:\\MobileData\\手机基站分时段统计_2017\\avg.csv";
        static string outPath03 = "E:\\MobileData\\手机基站分时段统计_2017\\count.csv";

        static void Main(string[] args)
        {

            Console.CursorVisible = false;
            //连接数据库
            string DB_name = "WuHan_GSM201603";
            bool isOpen = false;
            SqlConnection sCon = SQLconnecting(DB_name, ref isOpen);
            if (!isOpen)
            {
                Console.WriteLine("————数据库连接错误，按任意键退出。————");
                Console.ReadKey();
                
            }
            string sqlMessage;
            SqlCommand sCmd = new SqlCommand();
            //连接基站数据表
            sqlMessage = "SELECT * FROM jzd201703";
            sCmd.Connection = sCon;
            sCmd.CommandText = sqlMessage ;
            sCmd.CommandTimeout = 3000;
            SqlDataReader sDR =  sCmd.ExecuteReader();
            DataTable jzDT = new DataTable();
            #region create table jzDT
            jzDT.Columns.Add("JZ_Number",typeof(long));
            jzDT.Columns.Add("lng",typeof(double));
            jzDT.Columns.Add("lat", typeof(double));
            jzDT.Columns.Add("lac", typeof(string));
            jzDT.Columns.Add("cid", typeof(string));
            jzDT.Columns.Add("loc_ID", typeof(string));
            #endregion
            while(sDR.Read())
            {
                DataRow jzRow = jzDT.NewRow();
                jzRow[0] = Convert.ToInt64(sDR[0]);
                jzRow[1] = Convert.ToDouble(sDR[1]);
                jzRow[2] = Convert.ToDouble(sDR[2]);
                jzRow[3] = Convert.ToString(sDR[3]);
                jzRow[4] = Convert.ToString(sDR[4]);
                jzDT.Rows.Add(jzRow);
            }
            sDR.Close();
            sCon.ResetStatistics();
            //定义result datatable
            DataTable nDT = createDT(jzDT, n_hours,typeof(int));
            //定义datatable_count
            DataTable nDT_count = createDT(jzDT, 7, typeof(int));
            //定义result_avg datatable
            DataTable nDT_avg = createDT(jzDT, n_hours, typeof(double));
            nDT_avg = nDT_avg.Clone();
            Console.WriteLine("————table建立完成！————");
            #region 统计 >>>
            
            int weekday = 3;    //2016年1号对应星期二、2017年1号对应星期三
            for(int i = 1; i <32; i++)
            {
                int day = -1;
                switch(weekday)
                {
                    case 1 : day = 0;break;
                    case 2 : day = 24;break;
                    case 3 : day = 48;break;
                    case 4 : day = 72;break;
                    case 5 : day = 96;break;
                    case 6 : day = 120;break;
                    case 0 : day = 144;break;
                    default: break;
                }
                //连接sql读取当天数据
                string search = "SELECT * FROM jzd201703 JOIN gsm_byHours_day" + i.ToString("D2") + " ON jzd201703.lac = gsm_byHours_day" + i.ToString("D2") + ".lac AND jzd201703.cid = gsm_byHours_day" + i.ToString("D2") + ".cid";
                SqlCommand tCmd = new SqlCommand();
                tCmd.Connection = sCon;
                tCmd.CommandText = search;
                tCmd.CommandTimeout = 3000;
                SqlDataReader tDR = tCmd.ExecuteReader();
                Console.Write("day" + i.ToString() + ":");
                int count = 1;
                int cursor_left = Console.CursorLeft;
                while (tDR.Read())
                {
                    DataRow[] tRow = nDT.Select("JZ_number = '"+ tDR["JZ_number"] + "'");
                    DataRow[] t_countRow = nDT_count.Select("JZ_number = '"+ tDR["JZ_number"] + "'");
                    tRow[0].BeginEdit();
                    for (int hour = 0; hour < 24; hour++)
                    {
                        int tHour = day + hour;
                        tRow[0][tHour.ToString()] = Convert.ToInt32( tRow[0][tHour.ToString()]) + Convert.ToInt32( tDR[hour.ToString()]);
                    }
                    t_countRow[0][weekday.ToString()] = Convert.ToInt32(t_countRow[0][weekday.ToString()]) + 1;
                    tRow[0].EndEdit();
                    t_countRow[0].EndEdit();

                    if (count % 500 == 0)
                    {
                        Console.SetCursorPosition(cursor_left, Console.CursorTop);
                        Console.Write(count.ToString());
                    }
                    count++;
                }
                Console.WriteLine();
                tDR.Close();
                weekday = (weekday + 1) % 7;
            }
            
            #endregion
            Console.WriteLine("————统计完成————");
            average(nDT, nDT_count, ref nDT_avg);
            SaveDT2CSV(nDT, outPath01);
            SaveDT2CSV(nDT_avg, outPath02);
            SaveDT2CSV(nDT_count, outPath03);
            Console.WriteLine("————all done!————");
            Console.ReadKey();

        }

        private static DataTable createDT(DataTable jz, int n, Type type)
        {
            DataTable resultDT = jz.Copy();
            for (int i = 0; i < n; i++)
            {
                resultDT.Columns.Add(i.ToString(), type);
            }
            for (int i = 0; i < resultDT.Rows.Count; i++)
                for (int j = 0; j < n; j++)
                {
                    resultDT.Rows[i][j.ToString()] = 0;
                }
            Console.WriteLine("create DT:{0}*{1}", resultDT.Rows.Count, n);
            return resultDT;
        }

        private static SqlConnection SQLconnecting(string name, ref bool Open)
        {
            string connString = "server=localhost;database=" + name + ";Integrated Security=True ";
            SqlConnection sConn = new SqlConnection(connString);
            try
            {
                sConn.Open();
                Open = true;
                Console.WriteLine("————成功链接数据库：" + name + "————");
            }
            catch (Exception ex)
            {
                Console.WriteLine("————链接错误：" + ex.Message + "————");
                Open = false;
            }
            return sConn;
        }

        private static void average(DataTable nDT,DataTable nDT_count, ref DataTable nDT_avg)
        {
            Console.WriteLine("————开始计算平均值————");

            for (int i = 0; i < nDT.Rows.Count; i++)
            {
                DataRow tempRow;
                tempRow = nDT.Rows[i];
                tempRow.BeginEdit();
                string jz = nDT.Rows[i]["JZ_Number"].ToString();
                DataRow[] countRow = nDT_count.Select("JZ_number = '" + jz + "'");
                for (int hour = 0; hour < 168; hour++)
                {
                    if (hour < 24)
                    {
                        if (Convert.ToInt32(countRow[0]["0"]) > 0)
                        {
                            object s = tempRow[hour.ToString()];
                            double a = Convert.ToDouble(tempRow[hour.ToString()]);
                            double b = Convert.ToDouble(countRow[0]["0"]);
                            tempRow[hour.ToString()] = a/b;
                        }
                        else tempRow[hour.ToString()] = 0;
                    }
                    else if (hour < 48)
                    {
                        if (Convert.ToInt32(countRow[0]["1"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["1"]);
                        else tempRow[hour.ToString()] = 0;
                    }
                    else if (hour < 72)
                    {
                        if (Convert.ToInt32(countRow[0]["2"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["2"]);
                        else tempRow[hour.ToString()] = 0;
                    }
                    else if (hour < 96)
                    {
                        if (Convert.ToInt32(countRow[0]["3"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["3"]);
                        else tempRow[hour.ToString()] = 0;
                    }
                    else if (hour < 120)
                    {
                        if (Convert.ToInt32(countRow[0]["4"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["4"]);
                        else tempRow[hour.ToString()] = 0;
                    }
                    else if (hour < 144)
                    {
                        if (Convert.ToInt32(countRow[0]["5"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["5"]);
                        else tempRow[hour.ToString()] = 0;

                    }
                    else if (hour < 168)
                    {
                        if (Convert.ToInt32(countRow[0]["6"]) > 0)
                            tempRow[hour.ToString()] = Convert.ToDouble(tempRow[hour.ToString()]) / Convert.ToDouble(countRow[0]["6"]);
                        else tempRow[hour.ToString()] = 0;
                    }
                }
                tempRow.EndEdit();
                DataRow row = nDT_avg.NewRow();
                row.ItemArray = tempRow.ItemArray;
                nDT_avg.Rows.Add(row);
                Console.SetCursorPosition(0, Console.CursorTop);
                Console.Write("已完成：{0}%", i * 100 / nDT.Rows.Count);
            }
            Console.WriteLine();
            Console.WriteLine("————完成计算平均值————");
        }

        private static void SaveDT2CSV(DataTable dt, string fullPath)
        {
            FileInfo fi = new FileInfo(fullPath);
            if (!fi.Directory.Exists)
            {
                fi.Directory.Create();
            }
            FileStream fs = new FileStream(fullPath, System.IO.FileMode.Create, System.IO.FileAccess.Write);
            //StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);
            StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.UTF8);
            string data = "";
            //写出列名称
            for (int i = 0; i < dt.Columns.Count; i++)
            {
                data += dt.Columns[i].ColumnName.ToString();
                if (i < dt.Columns.Count - 1)
                {
                    data += ",";
                }
            }
            sw.WriteLine(data);
            //写出各行数据
            for (int i = 0; i < dt.Rows.Count; i++)
            {
                data = "";
                for (int j = 0; j < dt.Columns.Count; j++)
                {
                    string str = dt.Rows[i][j].ToString();
                    str = str.Replace("\"", "\"\"");//替换英文引号 英文引号需要换成两个引号
                    if (str.Contains(',') || str.Contains('"')
                        || str.Contains('\r') || str.Contains('\n')) //含逗号 冒号 换行符的需要放到引号中
                    {
                        str = string.Format("\"{0}\"", str);
                    }

                    data += str;
                    if (j < dt.Columns.Count - 1)
                    {
                        data += ",";
                    }
                }
                sw.WriteLine(data);
            }
            sw.Close();
            fs.Close();

        }

        private static DataTable ReadCsv2DT(string filename)
        {
            System.Data.DataTable nDT = new System.Data.DataTable();
            StreamReader sr = new StreamReader(filename);
            //读取表头
            string readerLine = sr.ReadLine();
            string[] reader = readerLine.Split(',');
            for (int i = 0; i < reader.Length; i++)
                nDT.Columns.Add(reader[i]);
            //读取数据
            readerLine = "";
            while ((readerLine = sr.ReadLine()) != null)
            {
                DataRow nDR = nDT.NewRow(); ;
                reader = readerLine.Split(',');
                for (int i = 0; i < reader.Length; i++)
                {
                    nDR[i] = reader[i];
                }
                nDT.Rows.Add(nDR);
            }
            sr.Dispose();


            return nDT;
        }
    }
}
